/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"bytes"
	"encoding/json"
	"fmt"
)

// checks if the PasswordResetRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &PasswordResetRequest{}

// PasswordResetRequest struct for PasswordResetRequest
type PasswordResetRequest struct {
	NewPassword string `json:"newPassword"`
}

type _PasswordResetRequest PasswordResetRequest

// NewPasswordResetRequest instantiates a new PasswordResetRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewPasswordResetRequest(newPassword string) *PasswordResetRequest {
	this := PasswordResetRequest{}
	this.NewPassword = newPassword
	return &this
}

// NewPasswordResetRequestWithDefaults instantiates a new PasswordResetRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewPasswordResetRequestWithDefaults() *PasswordResetRequest {
	this := PasswordResetRequest{}
	return &this
}

// GetNewPassword returns the NewPassword field value
func (o *PasswordResetRequest) GetNewPassword() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.NewPassword
}

// GetNewPasswordOk returns a tuple with the NewPassword field value
// and a boolean to check if the value has been set.
func (o *PasswordResetRequest) GetNewPasswordOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.NewPassword, true
}

// SetNewPassword sets field value
func (o *PasswordResetRequest) SetNewPassword(v string) {
	o.NewPassword = v
}

func (o PasswordResetRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o PasswordResetRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["newPassword"] = o.NewPassword
	return toSerialize, nil
}

func (o *PasswordResetRequest) UnmarshalJSON(data []byte) (err error) {
	// This validates that all required properties are included in the JSON object
	// by unmarshalling the object into a generic map with string keys and checking
	// that every required field exists as a key in the generic map.
	requiredProperties := []string{
		"newPassword",
	}

	allProperties := make(map[string]interface{})

	err = json.Unmarshal(data, &allProperties)

	if err != nil {
		return err
	}

	for _, requiredProperty := range requiredProperties {
		if _, exists := allProperties[requiredProperty]; !exists {
			return fmt.Errorf("no value given for required property %v", requiredProperty)
		}
	}

	varPasswordResetRequest := _PasswordResetRequest{}

	decoder := json.NewDecoder(bytes.NewReader(data))
	decoder.DisallowUnknownFields()
	err = decoder.Decode(&varPasswordResetRequest)

	if err != nil {
		return err
	}

	*o = PasswordResetRequest(varPasswordResetRequest)

	return err
}

type NullablePasswordResetRequest struct {
	value *PasswordResetRequest
	isSet bool
}

func (v NullablePasswordResetRequest) Get() *PasswordResetRequest {
	return v.value
}

func (v *NullablePasswordResetRequest) Set(val *PasswordResetRequest) {
	v.value = val
	v.isSet = true
}

func (v NullablePasswordResetRequest) IsSet() bool {
	return v.isSet
}

func (v *NullablePasswordResetRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullablePasswordResetRequest(val *PasswordResetRequest) *NullablePasswordResetRequest {
	return &NullablePasswordResetRequest{value: val, isSet: true}
}

func (v NullablePasswordResetRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullablePasswordResetRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
